/*******************************************************************************
 * Copyright (c) 2024, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <iostream>

#include <string>
#include <iniparser.h>

#include "ini.h"
#include "conf.h"

confplus::Ini::Ini(){
}

confplus::Ini::~Ini(){
}

const char* confplus::Ini::getName(){
    return "ini";
}

const char* confplus::Ini::getVersion(){
    return "0.1";
}

const char* confplus::Ini::getAuthor(){
    return "Jan Koester";
}

void confplus::Ini::saveConfig(const char *path,const Config *conf){
    // dictionary *d=nullptr;
    // for(){
    //
    // }
}


void confplus::Ini::loadConfig(const char *path,Config *conf){
    dictionary *d;
    d=iniparser_load(path);

    int sc = iniparser_getnsec(d);

    for(int i=0; i < sc; ++i){
       const char* scname=iniparser_getsecname(d,i);
       Config::ConfigData *ckey=conf->setKey(scname);
       conf->setValue(ckey,0,iniparser_getstring(d,scname,nullptr));
    }

    iniparser_freedict(d);
}

